unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, {sad ja} jpeg, HiScoreTable;

const
  APPLICATION_ID = 'DELPHI_IGRA_3789548'; //ovo promenite u bilo sta, nikada ne sme biti 2 ista


type
  TForm1 = class(TForm)
    Pozadina1: TImage;
    Pozadina2: TImage;
    TimerPozadine: TTimer;
    Brod: TImage;
    Rocket: TImage;
    TimerRakete: TTimer;
    Kamen1: TImage;
    TimerKamenja: TTimer;
    Label1: TLabel;
    Timer1: TTimer;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure TimerPozadineTimer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TimerRaketeTimer(Sender: TObject);
    procedure TimerKamenjaTimer(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  path:string;
  raketa_leti:boolean;
  kamen_dole,kamen_desno:boolean;
  zivoti,poeni:integer;
  OldWidth,OldHeight:integer;

  names,points:string; //global app data (za hiscoretablu)

  RegionBroda,RegionRakete,RegionKamena : TRect;


implementation

{$R *.dfm}

function SetScreenResolution(Width, Height: integer): Longint;
var
  DeviceMode: TDeviceMode;
begin
    with DeviceMode do 
    begin
      dmSize := SizeOf(TDeviceMode);
      dmPelsWidth := Width;
      dmPelsHeight := Height;
      dmFields := DM_PELSWIDTH or DM_PELSHEIGHT;
    end;
    Result := ChangeDisplaySettings(DeviceMode, CDS_UPDATEREGISTRY);
end;


procedure TForm1.FormCreate(Sender: TObject);
var visina_pozadine : integer;
begin
//sakrijemo kursor
ShowCursor(false);
//pokupimo staru rezoluciju
  OldWidth := GetSystemMetrics(SM_CXSCREEN);
  OldHeight := GetSystemMetrics(SM_CYSCREEN);
//pa promenimo na 800x600 (ako nije ta)
if OldWidth<>800 then SetScreenResolution(800, 600);
//maksimiziramo formu
Form1.WindowState:=wsMaximized;
//obojimo je u crno za svaki slucaj :P
Form1.Color:=clBlack;

//HiScore table unit by Avram se koristi za Tabeluuu
//kopirao sam iz mog demoa za hiscoretable pa su comments na engl.
//enumerate table
Label2.Caption:='1. '+#13+'2. '+#13+'3. '+#13+'4. '+#13+'5. '+#13+'6. '+#13+'7. '+#13+'8. '+#13+'9. '+#13+'10. ';
//if table doesn't exist, create it, else - read data
  if HST_ReadTable(APPLICATION_ID)=false then begin
    HST_ResetTable;
    HST_WriteTable(APPLICATION_ID);
  end;
//validity verification
  if HST_CheckTable(APPLICATION_ID)=false then begin
    MessageBox(handle,'Tabela je menjana rucno i bice resetovana!','Greska!',MB_OK+MB_ICONERROR);
    HST_ResetTable;
    HST_WriteTable(APPLICATION_ID);
  end;
//display table
HST_DisplayTable(names,points);
Label3.Caption:=names;
Label4.Caption:=points;



//broj zivota na startu igre
zivoti := 3;

//definisi visinu pozadine (ekrana, igre)
visina_pozadine := 600;

//izvadi putanju do igre
path:=ExtractFilePath(Application.ExeName);
//osnova svake igre sto se tice 2D grafike bez DX-a (uklanja treperenje)
DoubleBuffered:=true;

//ucitaj i podesi pozadinu
pozadina1.Picture.LoadFromFile(path+'back.jpg');
//namesti je na pocetak
Pozadina1.Top:=0; Pozadina1.Left:=0;
//kreiraj jos jednu pozadinu (istu)
pozadina2.Picture.LoadFromFile(path+'back.jpg');
//pomeri drugu pozadinu tacno iznad prve za celu duzinu
Pozadina2.Top:=0 - visina_pozadine; Pozadina2.Left:=0;
//pokreni sliding
TimerPozadine.Enabled:=true;

//slazi program da je MDL ekstenzija u stvari BMP (tj. lazemo korisnike)
Brod.Picture.RegisterFileFormat('mdl','Bitmap file',TBitmap);
//ucitaj model :)
Brod.Picture.LoadFromFile(path+'ship.mdl');
//nek bidne transparentan
Brod.Transparent:=true;
//podesi mu poziciju (top je fiksna, left je centrirana :P)
Brod.Top:=Form1.Height-brod.Height;
brod.Left:=(Form1.Width div 2) - (Brod.Width div 2);

//slazi program da je MDL ekstenzija u stvari BMP (tj. lazemo korisnike)
Rocket.Picture.RegisterFileFormat('mdl','Bitmap file',TBitmap);
//ucitaj model :)
Rocket.Picture.LoadFromFile(path+'rocket.mdl');
//nek bidne transparentan
Rocket.Transparent:=true;
//sakrij je za pocetak
Rocket.Visible:=false;
//leti?
raketa_leti:=false;

//slazi program da je MDL ekstenzija u stvari BMP (tj. lazemo korisnike)
Kamen1.Picture.RegisterFileFormat('mdl','Bitmap file',TBitmap);
//ucitaj model :)
Kamen1.Picture.LoadFromFile(path+'rock1.mdl');
//nek bidne transparentan
Kamen1.Transparent:=true;
//randomizirana pozicija :P
randomize;
Kamen1.Top:=random(Form1.Height);
randomize;
Kamen1.Left:=random(Form1.Width);
//podesi mu putanje :)
kamen_dole:=true;
kamen_desno:=true;
//pokreni ga
TimerKamenja.Enabled:=true;




end;

procedure TForm1.TimerPozadineTimer(Sender: TObject);
var visina_pozadine : integer;
begin
//definisi visinu pozadine (ekrana, igre)
visina_pozadine := 600; //800x600 px
//pomeraj obe pozadine
Pozadina1.Top:=Pozadina1.Top+1;
Pozadina2.Top:=Pozadina2.Top+1;
//kada se prva pozadina pomeri skroooz dole, prebaci je gore (isto i za drugu)
if Pozadina1.Top = visina_pozadine then Pozadina1.Top:=0 - visina_pozadine;
if Pozadina2.Top = visina_pozadine then Pozadina2.Top:=0 - visina_pozadine;

end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//zatvaramo app. na eskejp 
if Key = vk_escape then form1.Close;

//pomeranje
if Key=vk_left then Brod.Left:=Brod.Left-5;
if Key=vk_right then Brod.Left:=Brod.Left+5;
//obezbedjivanje da ne ode sa ekrana
if Brod.Left<0 then Brod.Left:=0;
if (Brod.Left>(Form1.Width - Brod.Width)) then brod.Left:=Form1.Width - Brod.Width;

//ispaljivanje rakete
  if (Key = Ord(' ')) and not raketa_leti then begin
    Rocket.Top:=Form1.Height-Brod.Height-40; //40 je opet neki offset kod fullscreen-a
    Rocket.Left:=Brod.Left+(Brod.Width div 2)+5; //5 je fix za moj los crtez broda :)
    Rocket.Visible := true;
    TimerRakete.Enabled := true;
    raketa_leti := true;
  end;
end;

procedure TForm1.TimerRaketeTimer(Sender: TObject);
begin
//pomeraj je na gore
if Rocket.Top<(Form1.Height div 2) then Rocket.Top:=Rocket.Top-7
  else Rocket.Top:=Rocket.Top-3;

  //kad izadje sa ekrana...
  if Rocket.Top<(0 - Rocket.Height ) then begin
    Rocket.Visible := false;
    raketa_leti := False;
    TimerRakete.Enabled := False;
  end;

Application.ProcessMessages;
end;

procedure TForm1.TimerKamenjaTimer(Sender: TObject);
var jebeni_rect:TRect;
begin
//kretanje
if kamen_dole then Kamen1.Top:=Kamen1.Top+5
  else Kamen1.Top:=Kamen1.Top-5;
if kamen_desno then Kamen1.Left:=Kamen1.Left+5
  else Kamen1.Left:=Kamen1.Left-5;


//granice
if Kamen1.Left<0 then kamen_desno:=true;
if Kamen1.Left>(Form1.Width-Kamen1.Width) then kamen_desno:=false;
////////////////
if Kamen1.Top<0 then kamen_dole:=true;
if Kamen1.Top>(Form1.Height-Kamen1.Height) then kamen_dole:=false;



//sudaranja
RegionBroda := Rect(Brod.Left, Brod.Top, brod.Left+brod.Width, brod.Top+Brod.Height);
RegionRakete := Rect(Rocket.Left, Rocket.Top, rocket.left+Rocket.Width, rocket.top+Rocket.Height);
RegionKamena := Rect(Kamen1.Left, Kamen1.Top, kamen1.left+Kamen1.Width, kamen1.top+Kamen1.Height);

  //sudaranje (brod i kamen)
  if IntersectRect(jebeni_rect,RegionKamena,RegionBroda) = true then begin
    //prekini sa kretanjem kamena
    TimerKamenja.Enabled:=false;
    //smanji broj zivota
    zivoti := zivoti-1;
    //ucitaj sjebani brod
    Brod.Picture.LoadFromFile(path+'ship-fucked.mdl');
    //vrati normalan za 3 sec
    Timer1.Enabled:=true;
  end;

  //sudaranje (kamen i raketa)
  if (IntersectRect(jebeni_rect,RegionKamena,RegionRakete) = true) and raketa_leti then begin
    //ucitaj sjebani kamen
    Kamen1.Picture.LoadFromFile(path+'rock1-destroyed.mdl');
    //zaustavi kretanje kamena
    TimerKamenja.Enabled:=false;
    //za 3 sec vrati normalan kamen
    Timer1.Enabled:=true;
    //raketa se unistila, dakle ne leti, ne pomera se, ne vidi se
    raketa_leti := false;
    TimerRakete.Enabled := false;
    Rocket.Visible:=false;
    //dodajemo od 50 do 100 poena
    poeni := poeni + random(51) + 50;
  end;

//prikazivanje podataka
Label1.Caption:='Poeni: '+IntToStr(poeni)+#13#10+
                'Zivoti: '+IntToStr(zivoti);

  //kad se izgube zivoti
  if zivoti<1 then begin
    //add item to table
    HST_TableAddItem(InputBox('','Unesite Vase ime:',''),poeni);
    //refresh
    HST_DisplayTable(names,points);
    Label3.Caption:=names;
    Label4.Caption:=points;
    //write table
    HST_WriteTable(APPLICATION_ID);
    //onemoguci sve tajmere osim tajmera za skrol pozadine
    TimerRakete.Enabled:=false; TimerKamenja.Enabled:=false; Timer1.Enabled:=false;
    //pokazi tablu
    Label2.Show; Label3.Show; Label4.Show;

  end;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
//ucitaj normalan brod
Brod.Picture.LoadFromFile(path+'ship.mdl');
//baci kamen ko zna gde
    randomize;
    Kamen1.Top:=random(Form1.Height);
    randomize;
    Kamen1.Left:=random(Form1.Width);
    randomize;
//ucitaj normalan kamen
Kamen1.Picture.LoadFromFile(path+'rock1.mdl');
//pokreni ga
if zivoti>0 then TimerKamenja.Enabled:=true;
//prekini ovaj timer
Timer1.Enabled:=false;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//pri zatvaranju app moramo da vratimo staru rezoluciju ako smo je menjali
if OldWidth<>800 then SetScreenResolution(OldWidth, OldHeight);
end;

end.
